import 'dart:async';

import 'package:http/http.dart';

class TransformRequest extends BaseRequest {
  final BaseRequest source;
  final StreamTransformer<List<int>, List<int>> transformer;

  @override
  int? get contentLength => source.contentLength;

  @override
  set contentLength(int? value) => throw UnsupportedError('cannot change TransformRequest configuration');

  @override
  bool get persistentConnection => source.persistentConnection;

  @override
  set persistentConnection(bool value) => throw UnsupportedError('cannot change TransformRequest configuration');

  @override
  bool get followRedirects => source.followRedirects;

  @override
  set followRedirects(bool value) => throw UnsupportedError('cannot change TransformRequest configuration');

  @override
  int get maxRedirects => source.maxRedirects;

  @override
  set maxRedirects(int value) => throw UnsupportedError('cannot change TransformRequest configuration');

  @override
  Map<String, String> get headers => source.headers;

  TransformRequest(this.source, this.transformer) : super(source.method, source.url);

  @override
  ByteStream finalize() {
    super.finalize();
    return ByteStream(source.finalize().transform(transformer));
  }
}
